"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = __importDefault(require("color"));
var transport_1 = require("@connectv/sdh/transport");
var renderer_1 = require("../../../../../transport/renderer");
var switcher_1 = require("./switcher");
function postNavSearch() {
    var query = undefined;
    var switcher$;
    window.addEventListener('on-navigation-search', function (event) {
        query = event.detail.query;
    });
    window.addEventListener('navigation', function () {
        if (query)
            search(query);
        query = undefined;
    });
    var renderer = renderer_1.getRenderer();
    function search(query) {
        var q = query.toLowerCase();
        var highlights$ = [];
        var container$ = document.getElementById('-codedoc-container');
        if (container$) {
            var _scan_1 = function (el$) {
                if (el$ instanceof Text) {
                    var text = el$.textContent;
                    var index = text === null || text === void 0 ? void 0 : text.toLowerCase().indexOf(q);
                    if (text && index !== undefined && index > -1) {
                        var before = text.substr(0, index);
                        var match = text.substr(index, query.length);
                        var after = text.substr(index + query.length);
                        var color = color_1.default(window.getComputedStyle(el$.parentElement).color);
                        if (color.saturationv() < .2) {
                            color = color.isLight() ? 'teal' : 'yellow';
                        }
                        else
                            color = color.rotate(90).alpha(.35);
                        el$.textContent = after;
                        var before$ = document.createTextNode(before);
                        var match$ = renderer.create("span", { "data-no-search": true, style: "\n                              background: " + color.toString() + "; \n                              display: inline-block; \n                              vertical-align: middle;\n                              transform-origin: center;\n                              transition: transform .15s\n                              " }, match);
                        highlights$.push(match$);
                        renderer.render(renderer.create("fragment", null,
                            before$,
                            match$)).before(el$);
                        _scan_1(before$);
                        _scan_1(el$);
                    }
                }
                else {
                    if (el$ instanceof HTMLElement && el$.hasAttribute('data-no-search'))
                        return;
                    el$.childNodes.forEach(_scan_1);
                }
            };
            _scan_1(container$);
        }
        if (highlights$.length > 0) {
            if (switcher$)
                switcher$.remove();
            switcher$ = renderer.create(switcher_1.SearchSwitcher, { elements: highlights$ });
            renderer.render(switcher$).on(document.body);
        }
    }
    window._find = search;
}
exports.postNavSearch = postNavSearch;
exports.postNavSearch$ = transport_1.funcTransport(postNavSearch);
//# sourceMappingURL=index.js.map