import { state } from '@connectv/core';
import { ref } from '@connectv/html';
import { SearchSwitcherStyles } from './styles';
export function SearchSwitcher(options, renderer) {
    const classes = this.theme.classes(SearchSwitcherStyles);
    const holder = ref();
    const index = state(1);
    let focused = undefined;
    const focus = (element) => {
        var _a;
        if (focused)
            focused.style.transform = '';
        element.style.transform = 'scale(1.15)';
        focused = element;
        let parent = focused.parentElement;
        while (parent) {
            if (parent.hasAttribute('data-tab-title')) {
                const ref = parent.getAttribute('data-tab-title');
                const btn$ = (_a = parent
                    .parentElement) === null || _a === void 0 ? void 0 : _a.querySelector(`.selector>button[data-tab-title="${ref}"]`);
                if (btn$)
                    btn$.click();
            }
            parent = parent.parentElement;
        }
        setTimeout(() => focused === null || focused === void 0 ? void 0 : focused.scrollIntoView({ block: 'center' }), 300);
    };
    const next = () => {
        if (index.value >= options.elements.length)
            index.value = 1;
        else
            index.value++;
        focus(options.elements[index.value - 1]);
    };
    const prev = () => {
        if (index.value <= 1)
            index.value = options.elements.length;
        else
            index.value--;
        focus(options.elements[index.value - 1]);
    };
    this.track({
        bind() {
            focus(options.elements[0]);
        },
        clear() {
            options.elements.forEach(element => {
                renderer.render(renderer.create("fragment", null, element.textContent)).before(element);
                element.remove();
            });
        }
    });
    return renderer.create("div", { class: classes.holder, _ref: holder },
        renderer.create("span", { class: "icon-font", onclick: () => holder.$.remove() }, "close"),
        renderer.create("span", { class: "icon-font", onclick: () => {
                var _a;
                holder.$.remove();
                (_a = document.getElementById('-codedoc-search-btn')) === null || _a === void 0 ? void 0 : _a.click();
            } }, "list"),
        renderer.create("span", { class: classes.content },
            index,
            "/",
            options.elements.length),
        renderer.create("span", { class: "icon-font", onclick: prev }, "chevron_left"),
        renderer.create("span", { class: "icon-font", onclick: next }, "chevron_right"));
}
//# sourceMappingURL=switcher.js.map